/*
 * 5kk73 GPU assignment
 */

/* Dense Stereo Vision
 * Device code.
 */

//#include <stdio.h>
#include "stereo.h"


////////////////////////////////////////////////////////////////////////////////
//! Stereo Vision
////////////////////////////////////////////////////////////////////////////////
__global__ void
stereo(unsigned char *d_inLeft, unsigned char *d_inRight, unsigned char *d_outLeft, int imageWidth)
{
    // Block index
    int bx = blockIdx.x;
    int by = blockIdx.y;

    // Thread index
    int tx = threadIdx.x;
    int ty = threadIdx.y;
    
    /******************************************************
     * This is an empty kernel.
     * It just copies the left image to the output file.
     * No disparity map is generated by GPU.
     * You need to write your disparity code using CUDA.
     *****************************************************/

    uchar4 *packed_d_inLeft = (uchar4 *)d_inLeft;
    uchar4 *packed_d_outLeft = (uchar4 *)d_outLeft;

    unsigned int index = (by * BLOCK_SIZE_Y + ty) * (imageWidth / 4) + (bx * BLOCK_SIZE_X + tx);
    packed_d_outLeft[index] = packed_d_inLeft[index];
    
}

